<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>NTLMScheme xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/auth/NTLMScheme.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/auth/NTLMScheme.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/auth/package-summary.html">org.apache.commons.httpclient.auth</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> org.apache.commons.httpclient.Credentials;
<a name="34" href="#34">34</a>  <strong>import</strong> org.apache.commons.httpclient.HttpMethod;
<a name="35" href="#35">35</a>  <strong>import</strong> org.apache.commons.httpclient.NTCredentials;
<a name="36" href="#36">36</a>  <strong>import</strong> org.apache.commons.logging.Log;
<a name="37" href="#37">37</a>  <strong>import</strong> org.apache.commons.logging.LogFactory;
<a name="38" href="#38">38</a>  
<a name="39" href="#39">39</a>  <em>/**<em>* An implementation of the Microsoft proprietary NTLM authentication scheme.  For a detailed</em></em>
<a name="40" href="#40">40</a>  <em> * explanation of the NTLM scheme please see &lt;a href="<a href="http://davenport.sourceforge.net/ntlm.html" target="alexandria_uri">http://davenport.sourceforge.net/ntlm.html</a>"></em>
<a name="41" href="#41">41</a>  <em> * <a href="http://davenport.sourceforge.net/ntlm.html&lt;/a" target="alexandria_uri">http://davenport.sourceforge.net/ntlm.html&lt;/a</a>>.</em>
<a name="42" href="#42">42</a>  <em> * </em>
<a name="43" href="#43">43</a>  <em> * @author &lt;a href="<a href="mailto:remm@apache.org" target="alexandria_uri">mailto:remm@apache.org</a>">Remy Maucherat&lt;/a></em>
<a name="44" href="#44">44</a>  <em> * @author Rodney Waldhoff</em>
<a name="45" href="#45">45</a>  <em> * @author &lt;a href="<a href="mailto:jsdever@apache.org" target="alexandria_uri">mailto:jsdever@apache.org</a>">Jeff Dever&lt;/a></em>
<a name="46" href="#46">46</a>  <em> * @author Ortwin Gl???ck</em>
<a name="47" href="#47">47</a>  <em> * @author Sean C. Sullivan</em>
<a name="48" href="#48">48</a>  <em> * @author &lt;a href="<a href="mailto:adrian@ephox.com" target="alexandria_uri">mailto:adrian@ephox.com</a>">Adrian Sutton&lt;/a></em>
<a name="49" href="#49">49</a>  <em> * @author &lt;a href="<a href="mailto:mbowler@GargoyleSoftware.com" target="alexandria_uri">mailto:mbowler@GargoyleSoftware.com</a>">Mike Bowler&lt;/a></em>
<a name="50" href="#50">50</a>  <em> * @author &lt;a href="<a href="mailto:oleg@ural.ru" target="alexandria_uri">mailto:oleg@ural.ru</a>">Oleg Kalnichevski&lt;/a></em>
<a name="51" href="#51">51</a>  <em> */</em>
<a name="52" href="#52">52</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLMScheme.html">NTLMScheme</a> implements <a href="../../../../../org/apache/commons/httpclient/auth/AuthScheme.html">AuthScheme</a> {
<a name="53" href="#53">53</a>  
<a name="54" href="#54">54</a>      <em>/**<em>* Log object for this class. */</em></em>
<a name="55" href="#55">55</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> Log LOG = LogFactory.getLog(NTLMScheme.<strong>class</strong>);
<a name="56" href="#56">56</a>  
<a name="57" href="#57">57</a>      <em>/**<em>* <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a> challenge string. */</em></em>
<a name="58" href="#58">58</a>      <strong>private</strong> String ntlmchallenge = <strong>null</strong>;
<a name="59" href="#59">59</a>  
<a name="60" href="#60">60</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> UNINITIATED         = 0;
<a name="61" href="#61">61</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> INITIATED           = 1;
<a name="62" href="#62">62</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> TYPE1_MSG_GENERATED = 2;
<a name="63" href="#63">63</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> TYPE2_MSG_RECEIVED  = 3;
<a name="64" href="#64">64</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> TYPE3_MSG_GENERATED = 4;
<a name="65" href="#65">65</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <strong>int</strong> FAILED              = Integer.MAX_VALUE;
<a name="66" href="#66">66</a>  
<a name="67" href="#67">67</a>      <em>/**<em>* Authentication process state */</em></em>
<a name="68" href="#68">68</a>      <strong>private</strong> <strong>int</strong> state;
<a name="69" href="#69">69</a>      
<a name="70" href="#70">70</a>      <em>/**<em>*</em></em>
<a name="71" href="#71">71</a>  <em>     * Default constructor for the NTLM authentication scheme.</em>
<a name="72" href="#72">72</a>  <em>     * </em>
<a name="73" href="#73">73</a>  <em>     * @since 3.0</em>
<a name="74" href="#74">74</a>  <em>     */</em>
<a name="75" href="#75">75</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLMScheme.html">NTLMScheme</a>() {
<a name="76" href="#76">76</a>          <strong>super</strong>();
<a name="77" href="#77">77</a>          <strong>this</strong>.state = UNINITIATED;
<a name="78" href="#78">78</a>      }
<a name="79" href="#79">79</a>  
<a name="80" href="#80">80</a>      <em>/**<em>*</em></em>
<a name="81" href="#81">81</a>  <em>     * Constructor for the NTLM authentication scheme.</em>
<a name="82" href="#82">82</a>  <em>     * </em>
<a name="83" href="#83">83</a>  <em>     * @param challenge The authentication challenge</em>
<a name="84" href="#84">84</a>  <em>     * </em>
<a name="85" href="#85">85</a>  <em>     * @throws MalformedChallengeException is thrown if the authentication challenge</em>
<a name="86" href="#86">86</a>  <em>     * is malformed</em>
<a name="87" href="#87">87</a>  <em>     */</em>
<a name="88" href="#88">88</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLMScheme.html">NTLMScheme</a>(<strong>final</strong> String challenge) throws MalformedChallengeException {
<a name="89" href="#89">89</a>          <strong>super</strong>();
<a name="90" href="#90">90</a>          processChallenge(challenge);
<a name="91" href="#91">91</a>      }
<a name="92" href="#92">92</a>  
<a name="93" href="#93">93</a>      <em>/**<em>*</em></em>
<a name="94" href="#94">94</a>  <em>     * Processes the NTLM challenge.</em>
<a name="95" href="#95">95</a>  <em>     *  </em>
<a name="96" href="#96">96</a>  <em>     * @param challenge the challenge string</em>
<a name="97" href="#97">97</a>  <em>     * </em>
<a name="98" href="#98">98</a>  <em>     * @throws MalformedChallengeException is thrown if the authentication challenge</em>
<a name="99" href="#99">99</a>  <em>     * is malformed</em>
<a name="100" href="#100">100</a> <em>     * </em>
<a name="101" href="#101">101</a> <em>     * @since 3.0</em>
<a name="102" href="#102">102</a> <em>     */</em>
<a name="103" href="#103">103</a>     <strong>public</strong> <strong>void</strong> processChallenge(<strong>final</strong> String challenge) throws MalformedChallengeException {
<a name="104" href="#104">104</a>         String s = AuthChallengeParser.extractScheme(challenge);
<a name="105" href="#105">105</a>         <strong>if</strong> (!s.equalsIgnoreCase(getSchemeName())) {
<a name="106" href="#106">106</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/MalformedChallengeException.html">MalformedChallengeException</a>(<span class="string">"Invalid NTLM challenge: "</span> + challenge);
<a name="107" href="#107">107</a>         }
<a name="108" href="#108">108</a>         <strong>int</strong> i = challenge.indexOf(' ');
<a name="109" href="#109">109</a>         <strong>if</strong> (i != -1) {
<a name="110" href="#110">110</a>             s = challenge.substring(i, challenge.length());
<a name="111" href="#111">111</a>             <strong>this</strong>.ntlmchallenge = s.trim();
<a name="112" href="#112">112</a>             <strong>this</strong>.state = TYPE2_MSG_RECEIVED;
<a name="113" href="#113">113</a>         } <strong>else</strong> {
<a name="114" href="#114">114</a>             <strong>this</strong>.ntlmchallenge = <span class="string">""</span>;
<a name="115" href="#115">115</a>             <strong>if</strong> (<strong>this</strong>.state == UNINITIATED) {
<a name="116" href="#116">116</a>                 <strong>this</strong>.state = INITIATED;
<a name="117" href="#117">117</a>             } <strong>else</strong> {
<a name="118" href="#118">118</a>                 <strong>this</strong>.state = FAILED;
<a name="119" href="#119">119</a>             }
<a name="120" href="#120">120</a>         }
<a name="121" href="#121">121</a>     }
<a name="122" href="#122">122</a> 
<a name="123" href="#123">123</a>     <em>/**<em>*</em></em>
<a name="124" href="#124">124</a> <em>     * Tests if the NTLM authentication process has been completed.</em>
<a name="125" href="#125">125</a> <em>     * </em>
<a name="126" href="#126">126</a> <em>     * @return &lt;tt>true&lt;/tt> if Basic authorization has been processed,</em>
<a name="127" href="#127">127</a> <em>     *   &lt;tt>false&lt;/tt> otherwise.</em>
<a name="128" href="#128">128</a> <em>     * </em>
<a name="129" href="#129">129</a> <em>     * @since 3.0</em>
<a name="130" href="#130">130</a> <em>     */</em>
<a name="131" href="#131">131</a>     <strong>public</strong> <strong>boolean</strong> isComplete() {
<a name="132" href="#132">132</a>         <strong>return</strong> <strong>this</strong>.state == TYPE3_MSG_GENERATED || <strong>this</strong>.state == FAILED;
<a name="133" href="#133">133</a>     }
<a name="134" href="#134">134</a> 
<a name="135" href="#135">135</a>     <em>/**<em>*</em></em>
<a name="136" href="#136">136</a> <em>     * Returns textual designation of the NTLM authentication scheme.</em>
<a name="137" href="#137">137</a> <em>     * </em>
<a name="138" href="#138">138</a> <em>     * @return &lt;code>ntlm&lt;/code></em>
<a name="139" href="#139">139</a> <em>     */</em>
<a name="140" href="#140">140</a>     <strong>public</strong> String getSchemeName() {
<a name="141" href="#141">141</a>         <strong>return</strong> <span class="string">"ntlm"</span>;
<a name="142" href="#142">142</a>     }
<a name="143" href="#143">143</a> 
<a name="144" href="#144">144</a>     <em>/**<em>*</em></em>
<a name="145" href="#145">145</a> <em>     * The concept of an authentication realm is not supported by the NTLM </em>
<a name="146" href="#146">146</a> <em>     * authentication scheme. Always returns &lt;code>null&lt;/code>.</em>
<a name="147" href="#147">147</a> <em>     * </em>
<a name="148" href="#148">148</a> <em>     * @return &lt;code>null&lt;/code></em>
<a name="149" href="#149">149</a> <em>     */</em>
<a name="150" href="#150">150</a>     <strong>public</strong> String getRealm() {
<a name="151" href="#151">151</a>         <strong>return</strong> <strong>null</strong>;
<a name="152" href="#152">152</a>     }
<a name="153" href="#153">153</a>     
<a name="154" href="#154">154</a>     <em>/**<em>*</em></em>
<a name="155" href="#155">155</a> <em>     * Returns a String identifying the authentication challenge.  This is</em>
<a name="156" href="#156">156</a> <em>     * used, in combination with the host and port to determine if</em>
<a name="157" href="#157">157</a> <em>     * authorization has already been attempted or not.  Schemes which</em>
<a name="158" href="#158">158</a> <em>     * require multiple requests to complete the authentication should</em>
<a name="159" href="#159">159</a> <em>     * return a different value for each stage in the request.</em>
<a name="160" href="#160">160</a> <em>     * </em>
<a name="161" href="#161">161</a> <em>     * &lt;p>Additionally, the ID should take into account any changes to the</em>
<a name="162" href="#162">162</a> <em>     * authentication challenge and return a different value when appropriate.</em>
<a name="163" href="#163">163</a> <em>     * For example when the realm changes in basic authentication it should be</em>
<a name="164" href="#164">164</a> <em>     * considered a different authentication attempt and a different value should</em>
<a name="165" href="#165">165</a> <em>     * be returned.&lt;/p></em>
<a name="166" href="#166">166</a> <em>     * </em>
<a name="167" href="#167">167</a> <em>     * @return String a String identifying the authentication challenge.  The</em>
<a name="168" href="#168">168</a> <em>     * returned value may be null.</em>
<a name="169" href="#169">169</a> <em>     * </em>
<a name="170" href="#170">170</a> <em>     * @deprecated no longer used</em>
<a name="171" href="#171">171</a> <em>     */</em>
<a name="172" href="#172">172</a>     <strong>public</strong> String getID() {
<a name="173" href="#173">173</a>         <strong>return</strong> ntlmchallenge;
<a name="174" href="#174">174</a>     }
<a name="175" href="#175">175</a>     
<a name="176" href="#176">176</a>     <em>/**<em>*</em></em>
<a name="177" href="#177">177</a> <em>     * Returns the authentication parameter with the given name, if available.</em>
<a name="178" href="#178">178</a> <em>     * </em>
<a name="179" href="#179">179</a> <em>     * &lt;p>There are no valid parameters for NTLM authentication so this method always returns</em>
<a name="180" href="#180">180</a> <em>     * &lt;tt>null&lt;/tt>.&lt;/p></em>
<a name="181" href="#181">181</a> <em>     * </em>
<a name="182" href="#182">182</a> <em>     * @param name The name of the parameter to be returned</em>
<a name="183" href="#183">183</a> <em>     * </em>
<a name="184" href="#184">184</a> <em>     * @return the parameter with the given name</em>
<a name="185" href="#185">185</a> <em>     */</em>
<a name="186" href="#186">186</a>     <strong>public</strong> String getParameter(String name) {
<a name="187" href="#187">187</a>         <strong>if</strong> (name == <strong>null</strong>) {
<a name="188" href="#188">188</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Parameter name may not be null"</span>); 
<a name="189" href="#189">189</a>         }
<a name="190" href="#190">190</a>         <strong>return</strong> <strong>null</strong>;
<a name="191" href="#191">191</a>     }
<a name="192" href="#192">192</a> 
<a name="193" href="#193">193</a>     <em>/**<em>*</em></em>
<a name="194" href="#194">194</a> <em>     * Returns &lt;tt>true&lt;/tt>. NTLM authentication scheme is connection based.</em>
<a name="195" href="#195">195</a> <em>     * </em>
<a name="196" href="#196">196</a> <em>     * @return &lt;tt>true&lt;/tt>.</em>
<a name="197" href="#197">197</a> <em>     * </em>
<a name="198" href="#198">198</a> <em>     * @since 3.0</em>
<a name="199" href="#199">199</a> <em>     */</em>
<a name="200" href="#200">200</a>     <strong>public</strong> <strong>boolean</strong> isConnectionBased() {
<a name="201" href="#201">201</a>         <strong>return</strong> <strong>true</strong>;    
<a name="202" href="#202">202</a>     }
<a name="203" href="#203">203</a> 
<a name="204" href="#204">204</a>     <em>/**<em>*</em></em>
<a name="205" href="#205">205</a> <em>     * Create a NTLM authorization string for the given</em>
<a name="206" href="#206">206</a> <em>     * challenge and NT credentials.</em>
<a name="207" href="#207">207</a> <em>     *</em>
<a name="208" href="#208">208</a> <em>     * @param challenge The challenge.</em>
<a name="209" href="#209">209</a> <em>     * @param credentials {@link NTCredentials}</em>
<a name="210" href="#210">210</a> <em>     *</em>
<a name="211" href="#211">211</a> <em>     * @return a ntlm authorization string</em>
<a name="212" href="#212">212</a> <em>     * @throws AuthenticationException is thrown if authentication fails</em>
<a name="213" href="#213">213</a> <em>     * </em>
<a name="214" href="#214">214</a> <em>     * @deprecated Use non-static {@link #authenticate(Credentials, HttpMethod)}</em>
<a name="215" href="#215">215</a> <em>     */</em>
<a name="216" href="#216">216</a>     <strong>public</strong> <strong>static</strong> String authenticate(
<a name="217" href="#217">217</a>      <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/NTCredentials.html">NTCredentials</a> credentials, <strong>final</strong> String challenge) 
<a name="218" href="#218">218</a>       throws <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a> {
<a name="219" href="#219">219</a> 
<a name="220" href="#220">220</a>         LOG.trace(<span class="string">"enter NTLMScheme.authenticate(NTCredentials, String)"</span>);
<a name="221" href="#221">221</a> 
<a name="222" href="#222">222</a>         <strong>if</strong> (credentials == <strong>null</strong>) {
<a name="223" href="#223">223</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Credentials may not be null"</span>);
<a name="224" href="#224">224</a>         }
<a name="225" href="#225">225</a>         
<a name="226" href="#226">226</a>         <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a> ntlm = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a>();
<a name="227" href="#227">227</a>         String s = ntlm.getResponseFor(challenge,
<a name="228" href="#228">228</a>         credentials.getUserName(), credentials.getPassword(),
<a name="229" href="#229">229</a>         credentials.getHost(), credentials.getDomain());
<a name="230" href="#230">230</a>         <strong>return</strong> <span class="string">"NTLM "</span> + s;
<a name="231" href="#231">231</a>     }
<a name="232" href="#232">232</a> 
<a name="233" href="#233">233</a>     <em>/**<em>*</em></em>
<a name="234" href="#234">234</a> <em>     * Create a NTLM authorization string for the given</em>
<a name="235" href="#235">235</a> <em>     * challenge and NT credentials.</em>
<a name="236" href="#236">236</a> <em>     *</em>
<a name="237" href="#237">237</a> <em>     * @param challenge The challenge.</em>
<a name="238" href="#238">238</a> <em>     * @param credentials {@link NTCredentials}</em>
<a name="239" href="#239">239</a> <em>     * @param charset The charset to use for encoding the credentials</em>
<a name="240" href="#240">240</a> <em>     *</em>
<a name="241" href="#241">241</a> <em>     * @return a ntlm authorization string</em>
<a name="242" href="#242">242</a> <em>     * @throws AuthenticationException is thrown if authentication fails</em>
<a name="243" href="#243">243</a> <em>     * </em>
<a name="244" href="#244">244</a> <em>     * @deprecated Use non-static {@link #authenticate(Credentials, HttpMethod)}</em>
<a name="245" href="#245">245</a> <em>     * </em>
<a name="246" href="#246">246</a> <em>     * @since 3.0</em>
<a name="247" href="#247">247</a> <em>     */</em>
<a name="248" href="#248">248</a>     <strong>public</strong> <strong>static</strong> String authenticate(
<a name="249" href="#249">249</a>         <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/NTCredentials.html">NTCredentials</a> credentials, 
<a name="250" href="#250">250</a> 		<strong>final</strong> String challenge,
<a name="251" href="#251">251</a> 		String charset
<a name="252" href="#252">252</a>     ) throws <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a> {
<a name="253" href="#253">253</a> 
<a name="254" href="#254">254</a>         LOG.trace(<span class="string">"enter NTLMScheme.authenticate(NTCredentials, String)"</span>);
<a name="255" href="#255">255</a> 
<a name="256" href="#256">256</a>         <strong>if</strong> (credentials == <strong>null</strong>) {
<a name="257" href="#257">257</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Credentials may not be null"</span>);
<a name="258" href="#258">258</a>         }
<a name="259" href="#259">259</a>         
<a name="260" href="#260">260</a>         <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a> ntlm = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a>();
<a name="261" href="#261">261</a>         ntlm.setCredentialCharset(charset);
<a name="262" href="#262">262</a>         String s = ntlm.getResponseFor(
<a name="263" href="#263">263</a>             challenge,
<a name="264" href="#264">264</a>             credentials.getUserName(), 
<a name="265" href="#265">265</a> 			credentials.getPassword(),
<a name="266" href="#266">266</a> 			credentials.getHost(), 
<a name="267" href="#267">267</a> 			credentials.getDomain());
<a name="268" href="#268">268</a>         <strong>return</strong> <span class="string">"NTLM "</span> + s;
<a name="269" href="#269">269</a>     }
<a name="270" href="#270">270</a>     
<a name="271" href="#271">271</a>     <em>/**<em>*</em></em>
<a name="272" href="#272">272</a> <em>     * Produces NTLM authorization string for the given set of </em>
<a name="273" href="#273">273</a> <em>     * {@link Credentials}.</em>
<a name="274" href="#274">274</a> <em>     * </em>
<a name="275" href="#275">275</a> <em>     * @param credentials The set of credentials to be used for athentication</em>
<a name="276" href="#276">276</a> <em>     * @param method Method name is ignored by the NTLM authentication scheme</em>
<a name="277" href="#277">277</a> <em>     * @param uri URI is ignored by the NTLM authentication scheme</em>
<a name="278" href="#278">278</a> <em>     * @throws InvalidCredentialsException if authentication credentials</em>
<a name="279" href="#279">279</a> <em>     *         are not valid or not applicable for this authentication scheme</em>
<a name="280" href="#280">280</a> <em>     * @throws AuthenticationException if authorization string cannot </em>
<a name="281" href="#281">281</a> <em>     *   be generated due to an authentication failure</em>
<a name="282" href="#282">282</a> <em>     * </em>
<a name="283" href="#283">283</a> <em>     * @return an NTLM authorization string</em>
<a name="284" href="#284">284</a> <em>     * </em>
<a name="285" href="#285">285</a> <em>     * @deprecated Use {@link #authenticate(Credentials, HttpMethod)}</em>
<a name="286" href="#286">286</a> <em>     */</em>
<a name="287" href="#287">287</a>     <strong>public</strong> String authenticate(<a href="../../../../../org/apache/commons/httpclient/Credentials.html">Credentials</a> credentials, String method, String uri) 
<a name="288" href="#288">288</a>       throws <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a> {
<a name="289" href="#289">289</a>         LOG.trace(<span class="string">"enter NTLMScheme.authenticate(Credentials, String, String)"</span>);
<a name="290" href="#290">290</a> 
<a name="291" href="#291">291</a>         <a href="../../../../../org/apache/commons/httpclient/NTCredentials.html">NTCredentials</a> ntcredentials = <strong>null</strong>;
<a name="292" href="#292">292</a>         <strong>try</strong> {
<a name="293" href="#293">293</a>             ntcredentials = (NTCredentials) credentials;
<a name="294" href="#294">294</a>         } <strong>catch</strong> (ClassCastException e) {
<a name="295" href="#295">295</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/InvalidCredentialsException.html">InvalidCredentialsException</a>(
<a name="296" href="#296">296</a>              <span class="string">"Credentials cannot be used for NTLM authentication: "</span> 
<a name="297" href="#297">297</a>               + credentials.getClass().getName());
<a name="298" href="#298">298</a>         }
<a name="299" href="#299">299</a>         <strong>return</strong> NTLMScheme.authenticate(ntcredentials, <strong>this</strong>.ntlmchallenge);
<a name="300" href="#300">300</a>     }
<a name="301" href="#301">301</a>     
<a name="302" href="#302">302</a>     <em>/**<em>*</em></em>
<a name="303" href="#303">303</a> <em>     * Produces NTLM authorization string for the given set of </em>
<a name="304" href="#304">304</a> <em>     * {@link Credentials}.</em>
<a name="305" href="#305">305</a> <em>     * </em>
<a name="306" href="#306">306</a> <em>     * @param credentials The set of credentials to be used for athentication</em>
<a name="307" href="#307">307</a> <em>     * @param method The method being authenticated</em>
<a name="308" href="#308">308</a> <em>     * </em>
<a name="309" href="#309">309</a> <em>     * @throws InvalidCredentialsException if authentication credentials</em>
<a name="310" href="#310">310</a> <em>     *         are not valid or not applicable for this authentication scheme</em>
<a name="311" href="#311">311</a> <em>     * @throws AuthenticationException if authorization string cannot </em>
<a name="312" href="#312">312</a> <em>     *   be generated due to an authentication failure</em>
<a name="313" href="#313">313</a> <em>     * </em>
<a name="314" href="#314">314</a> <em>     * @return an NTLM authorization string</em>
<a name="315" href="#315">315</a> <em>     * </em>
<a name="316" href="#316">316</a> <em>     * @since 3.0</em>
<a name="317" href="#317">317</a> <em>     */</em>
<a name="318" href="#318">318</a>     <strong>public</strong> String authenticate(
<a name="319" href="#319">319</a>         <a href="../../../../../org/apache/commons/httpclient/Credentials.html">Credentials</a> credentials, 
<a name="320" href="#320">320</a>         <a href="../../../../../org/apache/commons/httpclient/HttpMethod.html">HttpMethod</a> method
<a name="321" href="#321">321</a>     ) throws <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a> {
<a name="322" href="#322">322</a>         LOG.trace(<span class="string">"enter NTLMScheme.authenticate(Credentials, HttpMethod)"</span>);
<a name="323" href="#323">323</a> 
<a name="324" href="#324">324</a>         <strong>if</strong> (<strong>this</strong>.state == UNINITIATED) {
<a name="325" href="#325">325</a>             <strong>throw</strong> <strong>new</strong> IllegalStateException(<span class="string">"NTLM authentication process has not been initiated"</span>);
<a name="326" href="#326">326</a>         }
<a name="327" href="#327">327</a> 
<a name="328" href="#328">328</a>         <a href="../../../../../org/apache/commons/httpclient/NTCredentials.html">NTCredentials</a> ntcredentials = <strong>null</strong>;
<a name="329" href="#329">329</a>         <strong>try</strong> {
<a name="330" href="#330">330</a>             ntcredentials = (NTCredentials) credentials;
<a name="331" href="#331">331</a>         } <strong>catch</strong> (ClassCastException e) {
<a name="332" href="#332">332</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/InvalidCredentialsException.html">InvalidCredentialsException</a>(
<a name="333" href="#333">333</a>                     <span class="string">"Credentials cannot be used for NTLM authentication: "</span> 
<a name="334" href="#334">334</a>                     + credentials.getClass().getName());
<a name="335" href="#335">335</a>         }
<a name="336" href="#336">336</a>         <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a> ntlm = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/NTLM.html">NTLM</a>();
<a name="337" href="#337">337</a>         ntlm.setCredentialCharset(method.getParams().getCredentialCharset());
<a name="338" href="#338">338</a>         String response = <strong>null</strong>;
<a name="339" href="#339">339</a>         <strong>if</strong> (<strong>this</strong>.state == INITIATED || <strong>this</strong>.state == FAILED) {
<a name="340" href="#340">340</a>             response = ntlm.getType1Message(
<a name="341" href="#341">341</a>                 ntcredentials.getHost(), 
<a name="342" href="#342">342</a>                 ntcredentials.getDomain());
<a name="343" href="#343">343</a>             <strong>this</strong>.state = TYPE1_MSG_GENERATED;
<a name="344" href="#344">344</a>         } <strong>else</strong> {
<a name="345" href="#345">345</a>             response = ntlm.getType3Message(
<a name="346" href="#346">346</a>                 ntcredentials.getUserName(), 
<a name="347" href="#347">347</a>                 ntcredentials.getPassword(),
<a name="348" href="#348">348</a>                 ntcredentials.getHost(), 
<a name="349" href="#349">349</a>                 ntcredentials.getDomain(),
<a name="350" href="#350">350</a>                 ntlm.parseType2Message(<strong>this</strong>.ntlmchallenge));
<a name="351" href="#351">351</a>             <strong>this</strong>.state = TYPE3_MSG_GENERATED;
<a name="352" href="#352">352</a>         }
<a name="353" href="#353">353</a>         <strong>return</strong> <span class="string">"NTLM "</span> + response;
<a name="354" href="#354">354</a>     }    
<a name="355" href="#355">355</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

